# -*- coding: utf-8 -*-
# gui.py
## Menue umgebaut fuer Dateizugriffe
## und andere Moebeltypen

from grafikfenster import *

import os # notwendig fuer die Dateizugriffe
import platform
versionsNummer=platform.python_version()[0]
from konfigurationKlassenKarte import KonfigurationKlassenKarte
from konfigurationAttribut import KonfigurationAttribut
from konfigurationMethode import KonfigurationMethode
from konfigurationVerbinder import KonfigurationVerbinder
from konfigurationReihenfolge import KonfigurationReihenfolge

### ----- GUI -----------------------------------------
class Gui(wx.Frame):
        
    def __init__(
            self, parent, ID, title, pos=wx.DefaultPosition,
            size=wx.DefaultSize, style=wx.DEFAULT_FRAME_STYLE
            ):

        wx.Frame.__init__(self, parent, ID, title, pos, size, style)
        if 'wxMSW' in wx.PlatformInfo:
            size=self.GetSize()
            self.SetSize((size[0]+25,size[1]+25))
        panel = wx.Panel(self, -1)

        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

        ### ----- Button - Abschnitt -----
        waehleButton = wx.Button(panel, -1, "Auswaehlen")
        waehleButton.SetPosition((15, 15))
        self.Bind(wx.EVT_BUTTON, self.OnWaehlen, waehleButton)

        endeButton = wx.Button(panel, -1, "Beenden")
        endeButton.SetPosition((265, 15))
        self.Bind(wx.EVT_BUTTON, self.OnCloseMe, endeButton)

        ### ----- StaticText - Abschnitt -----
        self.projektCaption = wx.StaticText(panel, -1, "Projekt:")
        self.projektCaption.SetPosition((5, 60))
        self.projektName = wx.StaticText(panel, -1, "")
        self.projektName.SetPosition((75, 60))
        self.textKlassenName = wx.StaticText(panel, -1, u"keine Karte ausgewählt")
        self.textKlassenName.SetPosition((15, 90))
        
        ### ----- Textfeld - Abschnitt -----
        self.textX = wx.StaticText(panel, -1, "x-Position:")
        self.textX.SetPosition((45, 120))
        self.xEdit = wx.TextCtrl(panel, -1, "", size=(100, -1))
        self.xEdit.SetPosition((165, 115))
        self.Bind(wx.EVT_TEXT, self.EvtXEdit, self.xEdit)

        self.textY = wx.StaticText(panel, -1, "y-Position:")
        self.textY.SetPosition((45, 160))
        self.yEdit = wx.TextCtrl(panel, -1, "", size=(100, -1))
        self.yEdit.SetPosition((165, 155))
        self.Bind(wx.EVT_TEXT, self.EvtYEdit, self.yEdit)

        ### ----- Menue - Abschnitt -----
        menuBar = wx.MenuBar()

        dateiMenue = wx.Menu()
        dateiMenue.Append(101, "&Oeffnen", "Oeffnen")
        dateiMenue.Append(102, "&Speichern", "Speichern")
        dateiMenue.AppendSeparator()
        dateiMenue.Append(110, "ohne Attr/Meth Speichern")
        dateiMenue.AppendSeparator()
        dateiMenue.Append(103, "B&eenden", "Beenden")
        menuBar.Append(dateiMenue, "&Datei")

        neuMenue = wx.Menu()
        neuMenue.Append(201, "neue Klasse")
        neuMenue.Append(202, "neues Attribut")
        neuMenue.Append(203, "neue Methode")
        neuMenue.AppendSeparator()
        neuMenue.Append(211, "neue Assoziation")
        neuMenue.Append(212, "neue Aggregation")
        neuMenue.Append(213, "neue Komposition")
        neuMenue.Append(214, "neue Vererbung")
        menuBar.Append(neuMenue, "&Neu")

        bearbeitenMenue = wx.Menu()
        bearbeitenMenue.Append(301,"Attribut bearbeiten")
        bearbeitenMenue.Append(302,"Methode bearbeiten")
        bearbeitenMenue.Append(303,"Verbinder bearbeiten")
        bearbeitenMenue.AppendSeparator()
        bearbeitenMenue.Append(300, "Klasse waehlen")
        bearbeitenMenue.Append(310,"Klasse bearbeiten")
        bearbeitenMenue.AppendSeparator()
        bearbeitenMenue.Append(312, "Nur eine Klasse zeigen")
        bearbeitenMenue.Append(313, "Neu alle zeigen")
        menuBar.Append(bearbeitenMenue, "&Bearbeiten")

        sortierenMenue = wx.Menu()
        sortierenMenue.Append(401, "Attribute sortieren")
        sortierenMenue.Append(402, "Methoden sortieren")
        sortierenMenue.Append(403, "Parameter sortieren")
        menuBar.Append(sortierenMenue, "&Sortieren")

        loeschenMenue = wx.Menu()
        loeschenMenue.Append(501, "Klasse loeschen")
        loeschenMenue.Append(502, "Attribut loeschen")
        loeschenMenue.Append(503, "Methode loeschen")
        loeschenMenue.Append(504, "Parameter loeschen")
        loeschenMenue.Append(505, "Verbinder loeschen")
        menuBar.Append(loeschenMenue, "&Loeschen")

        menuBild = wx.Menu()
        menuBild.Append(601, "Bild &exportieren", "Bild als jpg/png exportieren")
        menuBar.Append(menuBild, "&Bild")

        menuCode = wx.Menu()
        menuCode.Append(701, "Code &exportieren", "Programmcode zur Klasse exportieren")
        menuBar.Append(menuCode, "&Code")

        # Menubar hinzufuegen
        self.SetMenuBar(menuBar)

        # Ereignisse verknuepfen
        self.Bind(wx.EVT_MENU, self.OnLaden, id=101)
        self.Bind(wx.EVT_MENU, self.OnSpeichern, id=102)
        self.Bind(wx.EVT_MENU, self.OnNurMitNamen, id=110)
        self.Bind(wx.EVT_MENU, self.OnCloseMe, id=103)

        self.Bind(wx.EVT_MENU, self.OnKlasse, id=201)
        self.Bind(wx.EVT_MENU, self.OnAttribut, id=202)
        self.Bind(wx.EVT_MENU, self.OnMethode, id=203)
        self.Bind(wx.EVT_MENU, self.OnAssoziation, id=211)
        self.Bind(wx.EVT_MENU, self.OnAggregation, id=212)
        self.Bind(wx.EVT_MENU, self.OnKomposition, id=213)
        self.Bind(wx.EVT_MENU, self.OnVererbung, id=214)
        
        self.Bind(wx.EVT_MENU, self.OnAttributBearbeiten, id=301)
        self.Bind(wx.EVT_MENU, self.OnMethodeBearbeiten, id=302)
        self.Bind(wx.EVT_MENU, self.OnVerbinderBearbeiten, id=303)
        self.Bind(wx.EVT_MENU, self.OnWaehlen, id=300)
        self.Bind(wx.EVT_MENU, self.OnKlasseBearbeiten, id=310)
        self.Bind(wx.EVT_MENU, self.OnNurEineZeigen, id=312)
        self.Bind(wx.EVT_MENU, self.OnAlleZeigen, id=313)
        
        self.Bind(wx.EVT_MENU, self.OnAttributeSortieren, id=401)
        self.Bind(wx.EVT_MENU, self.OnMethodenSortieren, id=402)
        self.Bind(wx.EVT_MENU, self.OnParameterSortieren, id=403)

        self.Bind(wx.EVT_MENU, self.OnKlasseLoeschen, id=501)
        self.Bind(wx.EVT_MENU, self.OnAttributLoeschen, id=502)
        self.Bind(wx.EVT_MENU, self.OnMethodeLoeschen, id=503)
        self.Bind(wx.EVT_MENU, self.OnParameterLoeschen, id=504)
        self.Bind(wx.EVT_MENU, self.OnVerbinderLoeschen, id=505)

        self.Bind(wx.EVT_MENU, self.OnBildExport, id=601)
        
        self.Bind(wx.EVT_MENU, self.OnCodeExport, id=701)

        self.__controller=None
        
    def SetzeController(self, controller):
        self.__controller=controller
        self.__sperreEreignisbehandlung=False # der TextCtrl

    def SetzeBeschriftungKlasse(self, text,x,y):
        self.textKlassenName.SetLabel(text)
        self.xEdit.SetValue(x)
        self.yEdit.SetValue(y)

    ### ----- Datei-Abschnitt ----------------------
    # Dateidialoge aus dem Demo-Programm 
    def OnLaden(self, event):
        if self.__controller.HatDaten():
            dlg = wx.MessageDialog(self, u'Alle vorhandenen Objekte löschen?',
                                   'Sicherheitsabfrage',
                                   wx.YES_NO)
            returnValue = dlg.ShowModal()
            if returnValue == wx.ID_NO:
                dlg.Destroy()
                return
            dlg.Destroy()
        verzeichnis = 'ModellDaten'
        if versionsNummer=='2': 
            dlg = wx.FileDialog(
                self, message=u"Datei wählen",
                defaultDir=verzeichnis, 
                defaultFile="daten.umlpy",
                style=wx.OPEN
                )
        else:
            dlg = wx.FileDialog(
                self, message=u"Datei wählen",
                defaultDir=verzeichnis, 
                defaultFile="daten.umlpy",
                style=wx.FD_OPEN
                )
        if dlg.ShowModal() == wx.ID_OK:
            dateiname = dlg.GetPath()
            antwort=self.__controller.Lade(dateiname)
            if antwort==None:
                message = wx.MessageDialog(self, 'Fehler beim Lesen',
                                           'Achtung',
                                           wx.OK | wx.ICON_WARNING)
                message.ShowModal()
                message.Destroy()
            else:
                if self.__controller.GibProjektNamen()!=None:
                    self.projektName.SetLabel(self.__controller.GibProjektNamen())
                else: self.projektName.SetLabel('')
        dlg.Destroy()

    def OnSpeichern(self, event):
        projektname=self.__controller.GibProjektNamen()
        if projektname!=None:
            dateiname=projektname+'.umlpy'
        else:
            dateiname="daten.umlpy"
        if versionsNummer=='2': 
            dlg = wx.FileDialog(
                self, message="Datei speichern", defaultDir="ModellDaten", 
                defaultFile=dateiname, style=wx.SAVE
                )
        else:
            dlg = wx.FileDialog(
                self, message="Datei speichern", defaultDir="ModellDaten", 
                defaultFile=dateiname, style=wx.FD_SAVE
                )
        if dlg.ShowModal() == wx.ID_OK:
            vollerDateiname = dlg.GetPath()
            antwort=self.__controller.Speichere(vollerDateiname)
            if antwort==None:
                message = wx.MessageDialog(self, 'Fehler beim Speichern',
                                           'Achtung',
                                           wx.OK | wx.ICON_WARNING)
                message.ShowModal()
                message.Destroy()
            else:
                self.projektName.SetLabel(self.__controller.GibProjektNamen())
        dlg.Destroy()

    def OnNurMitNamen(self, event):
        dlg = wx.MessageDialog(self, u'Klassendiagramm ohne\n Attribute und\n'+
                               'Methoden speichern?',
                               'Sicherheitsabfrage',
                               wx.YES_NO)
        returnValue = dlg.ShowModal()
        if returnValue == wx.ID_NO:
            dlg.Destroy()
            return
        if versionsNummer=='2': 
            dlg = wx.FileDialog(
                self, message="Daten ohne Attr/Meth speichern", defaultDir="ModellDaten", 
                defaultFile="daten.umlpy", style=wx.SAVE
                )
        else:
            dlg = wx.FileDialog(
                self, message="Daten ohne Attr/Meth speichern", defaultDir="ModellDaten", 
                defaultFile="daten.umlpy", style=wx.FD_SAVE
                )
        if dlg.ShowModal() == wx.ID_OK:
            dateiname = dlg.GetPath()
            antwort=self.__controller.SpeichereOhne(dateiname)
            if antwort==None:
                message = wx.MessageDialog(self, 'Fehler beim Speichern',
                                           'Achtung',
                                           wx.OK | wx.ICON_WARNING)
                message.ShowModal()
                message.Destroy()
        dlg.Destroy()

        

    def OnBildExport(self, event):
        if versionsNummer=='2': 
            dlg = wx.FileDialog(
                self, message="Bild exportierenn", defaultDir="Bilder", 
                defaultFile="Klassendiagramm.png", style=wx.SAVE
                )
        else:
            dlg = wx.FileDialog(
                self, message="Bild exportierenn", defaultDir="Bilder", 
                defaultFile="Klassendiagramm.png", style=wx.FD_SAVE
                )
        if dlg.ShowModal() == wx.ID_OK:
            dateiname = dlg.GetPath()
            antwort=self.__controller.BildExport(dateiname)
        dlg.Destroy()

    def OnCodeExport(self, event):
        if versionsNummer=='2': 
            dlg = wx.FileDialog(
                self, message="Code generieren und speichern", defaultDir="Code", 
                defaultFile="projekt.py", style=wx.SAVE
                )
        else:
            dlg = wx.FileDialog(
                self, message="Code generieren und speichern", defaultDir="Code", 
                defaultFile="projekt.py", style=wx.FD_SAVE
                )
        if dlg.ShowModal() == wx.ID_OK:
            dateiname = dlg.GetPath()
            antwort=self.__controller.SpeichereCode(dateiname)
            if antwort==None:
                message = wx.MessageDialog(self, 'Fehler beim Speichern',
                                           'Achtung',
                                           wx.OK | wx.ICON_WARNING)
                message.ShowModal()
                message.Destroy()
        dlg.Destroy()
        
        
    ### ----- Neu-Abschnitt ----------------------
    def OnKlasse(self, event):
        namen=self.__controller.GibKlassenNamen()
        dlg = wx.TextEntryDialog(
                self, 'Geben Sie den Namen der Klasse ein',
                'Neue Klasse', '')
        if dlg.ShowModal() == wx.ID_OK: name=dlg.GetValue()
        else: name=None
        dlg.Destroy()
        self.__controller.NeueKlasse(name)
        event.Skip()

    def OnAttribut(self, event):
        if self.__controller.NichtsAusgewaehlt(): return
        karte=self.__controller.GibAusgewaehlte()
        dlg = KonfigurationAttribut(
            self, -1,"Neues Attribut von:  "+karte.GibNamen(),
            '<Name>','<Typ>',False,False)
        dlg.CenterOnScreen()
        if dlg.ShowModal() == wx.ID_OK:
            try:
                self.__controller.NeuesAttribut(
                    dlg.textName.GetValue(),
                    dlg.textTyp.GetValue(),
                    dlg.cbAbstrakt.GetValue(),
                    dlg.cbClassVar.GetValue())
            except ValueError as e:
                pass
        dlg.Destroy()
        self.__controller.UpdateGrafikfenster()
        event.Skip()
        
    def OnMethode(self, event):
        if self.__controller.NichtsAusgewaehlt(): return
        karte=self.__controller.GibAusgewaehlte()
        ## Methodendaten: (<name>,<typ>, [(<par1>,<typ1>), ...], isStatic, isClassMet)
        dlg = KonfigurationMethode(self,-1,
                                   "Neue Methode von:  "+karte.GibNamen(),
                                   '<Name>',
                                   '<Typ>',
                                   '[("Parameter1","Typ1")]',
                                   False,
                                   False
                                   )
        dlg.CenterOnScreen()
        if dlg.ShowModal() == wx.ID_OK:
            parameter=[]
            for par in dlg.git.GibDaten():
                if par==("","") or par==("Parameter1","Typ1"):
                    continue
                parameter.append(par)
            try:
                self.__controller.NeueMethode(
                    dlg.textName.GetValue(),
                    dlg.textTyp.GetValue(),
                    parameter,
                    dlg.cbAbstrakt.GetValue(),
                    dlg.cbClMeth.GetValue()
                    )
            except ValueError as e:
                pass
        dlg.Destroy()
        self.__controller.UpdateGrafikfenster()
        event.Skip()

    def WaehleStartUndZiel(self):
        namen=self.__controller.GibKlassenNamen()
        start,startkante,ziel,zielkante=None,None,None,None
        
        start=self.Auswahldialog('Startkarte',namen)
        if start==None: return None,None,None,None
        startkante=self.Auswahldialog(
            'Kante der Startkarte',
            ['N', 'O', 'S', 'W'])
        if startkante==None: return None,None,None,None
        if start!=None: namen.remove(start)        
        ziel=self.Auswahldialog('Zielkarte',namen)
        if ziel==None: return None,None,None,None
        zielkante=self.Auswahldialog(
            'Kante der Zielkarte',
            ['N', 'O', 'S', 'W'])
        if zielkante==None: return None,None,None,None
        return start,startkante,ziel,zielkante
        

    def OnAssoziation(self, event):
        start,startkante,ziel,zielkante=self.WaehleStartUndZiel()
        if None in [start,startkante,ziel,zielkante]: return
        asso=self.__controller.NeueAssoziation(start,startkante,ziel,zielkante,typ=0)
        self.VerbinderDialogAufrufen(asso)
        event.Skip()

    def OnAggregation(self, event):
        start,startkante,ziel,zielkante=self.WaehleStartUndZiel()
        if None in [start,startkante,ziel,zielkante]: return
        asso=self.__controller.NeueAssoziation(start,startkante,ziel,zielkante,typ=1)        
        self.VerbinderDialogAufrufen(asso)
        event.Skip()

    def OnKomposition(self, event):
        start,startkante,ziel,zielkante=self.WaehleStartUndZiel()
        if None in [start,startkante,ziel,zielkante]: return
        asso=self.__controller.NeueAssoziation(start,startkante,ziel,zielkante,typ=2)    
        self.VerbinderDialogAufrufen(asso)
        event.Skip()

    def OnVererbung(self, event):
        start,startkante,ziel,zielkante=self.WaehleStartUndZiel()
        if None in [start,startkante,ziel,zielkante]: return
        istEin=self.__controller.NeueVererbung(start,startkante,ziel,zielkante)
        self.VerbinderDialogAufrufen(istEin)
        event.Skip()
        
    ### ----- Bearbeiten-Menue -----
    def OnAttributBearbeiten(self, event=None):
        if self.__controller.NichtsAusgewaehlt(): return
        karte=self.__controller.GibAusgewaehlte()
        n,xy,attribute,m,s=karte.GibDatenTextlich()
        attributliste=eval(attribute) # String zu Liste entpacken
        if attributliste==[]: return # nichts zu bearbeiten
        attributnamen=[] # Namen heraus holen
        for a in attributliste: attributnamen.append(a[0])
        attributBearbeiten=self.Auswahldialog(
            'Attribut bearbeiten',
            attributnamen
            )
        if attributBearbeiten==None: return
        typ,isAbstract,isClassVar=None,False,False #nur zum Initialisieren
        index=-1
        for attribut in attributliste:
            index+=1
            if attribut[0]==attributBearbeiten:
                if len(attribut)>2: isAbstract=attribut[2]
                if len(attribut)>3: isClassVar=attribut[3]
                break
        dlg = KonfigurationAttribut(
            self, -1,"Konfiguration Attribut von:  "+
                                   karte.GibNamen(),
            str(attributBearbeiten),
            str(typ),
            isAbstract,
            isClassVar
            )
        dlg.CenterOnScreen()
        if dlg.ShowModal() == wx.ID_OK:
            try:
                attributliste[index]=(
                    dlg.textName.GetValue(),
                    dlg.textTyp.GetValue(),
                    dlg.cbAbstrakt.GetValue(),
                    dlg.cbClassVar.GetValue())
                karte.SetzeAttributListe(attributliste)
            except ValueError as e:
                pass
        self.__controller.UpdateGrafikfenster()
        dlg.Destroy()
        event.Skip()
        
    def OnMethodeBearbeiten(self, event=None):
        if self.__controller.NichtsAusgewaehlt(): return
        karte=self.__controller.GibAusgewaehlte()
        n,xy,a,methoden,s=karte.GibDatenTextlich()
        methodenliste=eval(methoden) # String zu Liste entpacken
        if methodenliste==[]: return # nichts zu bearbeiten
        ## Methodendaten: (<name>,<typ>, [(<par1>,<typ1>), ...])
        methodennamen=[] # Namen heraus holen
        for m in methodenliste: methodennamen.append(m[0])
        methodeBearbeiten=self.Auswahldialog(
            'Methode bearbeiten',
            methodennamen
            )
        if methodeBearbeiten==None: return
        typ,parameter=None,None
        index=-1
        for methode in methodenliste:
            index+=1
            if methode[0]==methodeBearbeiten:
                typ=methode[1]
                parameter=methode[2]
                abstrakt=methode[3]
                if len(methode)>4: isClassMeth=methode[4]
                break
        if abstrakt in ['True','False']: abstrakt=eval(abstrakt)
        
        dlg = KonfigurationMethode(self,-1,
                                   "Konfiguration einer Methode von:  "+
                                   karte.GibNamen(),
                                   str(methodeBearbeiten),
                                   str(typ),
                                   str(parameter),
                                   abstrakt,
                                   isClassMeth
                                   )
        dlg.CenterOnScreen()
        if dlg.ShowModal() == wx.ID_OK:
            try:
                methodenliste[index]=(
                    dlg.textName.GetValue(),
                    dlg.textTyp.GetValue(),
                    dlg.git.GibDaten(),
                    dlg.cbAbstrakt.GetValue(),
                    dlg.cbClMeth.GetValue()
                    )
                karte.SetzeMethodenListe(methodenliste)
            except ValueError as e:
                pass
        self.__controller.UpdateGrafikfenster()
        dlg.Destroy()
        event.Skip()

    def OnKlasseBearbeiten(self, event=None):
        if self.__controller.NichtsAusgewaehlt(): return
        karte = self.__controller.GibAusgewaehlte()
        dlg = KonfigurationKlassenKarte(self, -1,
                                   'Klasse'+karte.GibNamen())
        name,abmessungen,attr,meth,abstrakt=karte.GibDatenTextlich()
        dlg.DatenSetzen(
            str(karte.GibX()),
            str(karte.GibY()),
            str(round(karte.GibBreite())),
            karte.IstAbstrakt()
            )
        dlg.CenterOnScreen()
        if dlg.ShowModal() == wx.ID_OK:
            try:
                karte.Bewege(round(float(dlg.textX.GetValue()))-karte.GibX(),
                             round(float(dlg.textY.GetValue()))-karte.GibY())
                karte.NeueBreite(round(float(dlg.textBreite.GetValue())))
                karte.SetzeAbstrakt(dlg.cbAbstrakt.GetValue())
                self.__controller.UpdateGrafikfenster()
            except ValueError as e:
                self.Meldung("Fehler beim Setzen der Daten!")
        dlg.Destroy()
        if event!=None: event.Skip()        

    def OnWaehlen(self, event):
        self.__controller.Waehle()
        ausgewaehlt=self.__controller.GibAusgewaehlte()
        if ausgewaehlt==None:
            self.xEdit.SetValue('')
            self.yEdit.SetValue('')
        else:
            self.xEdit.SetValue(str(ausgewaehlt.GibX()))
            self.yEdit.SetValue(str(ausgewaehlt.GibY()))
        event.Skip()

    def OnNurEineZeigen(self, event):
        self.__controller.VerbergeBisAufAusgewaehlte()
        event.Skip()
        
    def OnAlleZeigen(self, event):
        self.__controller.ZeigeAlle()
        event.Skip()

    def OnVerbinderBearbeiten(self, event):
        self.VerbinderKonfigurieren()
        event.Skip()

    def VerbinderKonfigurieren(self, die_kd_verbinder=None):
        '''ohne uebergebene Verbinder werden alle angeboten'''
        if die_kd_verbinder==None:
            die_kd_verbinder=self.__controller.GibVerbinder()
        verbinderTexte=self.__controller.GibVerbinderMitTyp(die_kd_verbinder)
        v_text=self.Auswahldialog("Verbinder waehlen:",verbinderTexte)
        if v_text==None: return
        kd_verbinder=die_kd_verbinder[verbinderTexte.index(v_text)]
        self.VerbinderDialogAufrufen(kd_verbinder)
        
    def VerbinderDialogAufrufen(self, kd_verbinder):
        s,sk,st,z,zk,zt,name,typ,verbTyp,ri=kd_verbinder.GibDatenTextlich()
        dlg = KonfigurationVerbinder(self, -1,'Verbinder',
                                     s, sk, st, z, zk, zt,
                                     name, int(typ), int(verbTyp), int(ri))
        dlg.CenterOnScreen()
        if dlg.ShowModal() == wx.ID_OK:
            try:
                kd_verbinder.SetzeStartKante(dlg.sk)
                kd_verbinder.NeuerTeilerStartKante(int(dlg.st))
                kd_verbinder.SetzeZielKante(dlg.zk)
                kd_verbinder.NeuerTeilerZielKante(int(dlg.zt))
                kd_verbinder.SetzeTyp(int(dlg.typ))
                kd_verbinder.SetzeVerbinderTyp(int(dlg.verbTyp))
                if kd_verbinder.GibTypNamen()!='Vererbung':
                    kd_verbinder.SetzeRichtung(int(dlg.ri))
            except ValueError as e:
                pass
        dlg.Destroy()

    ### ----- Sortieren-Menue ------------------------
    def OnAttributeSortieren(self, event):
        karte=self.__controller.GibAusgewaehlte()
        if karte==None: return
        n,xy,attribute,m,s=karte.GibDatenTextlich()
        attributliste=eval(attribute) # String zu Liste entpacken
        if attributliste==[]: return # nichts zu bearbeiten
        attributnamen=[] # Namen heraus holen
        for a in attributliste: attributnamen.append(a[0])
        liste=[]
        dlg = KonfigurationReihenfolge(self, -1,'Attribute sortieren',
            attributnamen)
        dlg.CenterOnScreen()
        if dlg.ShowModal() == wx.ID_OK:
            try:
                reihenfolgeString=dlg.textReihenfolge.GetValue()
                listeZeichen=reihenfolgeString.split(' ')
                liste=[]
                for zeichen in listeZeichen:
                    liste.append(int(zeichen))
            except ValueError as e:
                pass
        else:
            return
        if len(liste)!=len(attributnamen) or\
           max(liste)!=len(attributnamen):
            self.Meldung(u'Zahlenliste entspricht nicht'+
                         'der Anzahl der Attribute')
            return
        karte.SortiereAttribute(liste)
        dlg.Destroy()
        event.Skip()
    
    def OnMethodenSortieren(self, event):
        karte=self.__controller.GibAusgewaehlte()
        if karte==None: return
        n,xy,a,methoden,s=karte.GibDatenTextlich()
        methodenliste=eval(methoden) # String zu Liste entpacken
        if methodenliste==[]: return # nichts zu bearbeiten
        methodennamen=[] # Namen heraus holen
        for m in methodenliste: methodennamen.append(m[0])
        liste=[]
        dlg = KonfigurationReihenfolge(self, -1,'Attribute sortieren',
            methodennamen)
        dlg.CenterOnScreen()
        if dlg.ShowModal() == wx.ID_OK:
            try:
                reihenfolgeString=dlg.textReihenfolge.GetValue()
                listeZeichen=reihenfolgeString.split(' ')
                liste=[]
                for zeichen in listeZeichen:
                    liste.append(int(zeichen))
            except ValueError as e:
                pass
        else:
            return
        if len(liste)!=len(methodennamen) or\
           max(liste)!=len(methodennamen):
            self.Meldung(u'Zahlenliste entspricht nicht'+
                         'der Anzahl der Attribute')
            return
        karte.SortiereMethoden(liste)
        dlg.Destroy()
        event.Skip()
    
    def OnParameterSortieren(self, event):
        karte=self.__controller.GibAusgewaehlte()
        if karte==None: return
        n,xy,a,methoden,s=karte.GibDatenTextlich()
        methodenliste=eval(methoden) # String zu Liste entpacken
        if methodenliste==[]: return # nichts zu bearbeiten
        methodennamen=[] # Namen heraus holen
        for m in methodenliste: methodennamen.append(m[0])
        liste=[]
        name = self.Auswahldialog('Methode waehlen', methodennamen)
        if name==None: return
        parameterListe=karte.GibParameterZuMethName(name)
        parameterNamen=[]
        for par in parameterListe:
            parameterNamen.append(par[0])
        dlg = KonfigurationReihenfolge(self, -1,
                                       'Parameter sortieren zu Methode',
                                       parameterNamen)
        dlg.CenterOnScreen()
        if dlg.ShowModal() == wx.ID_OK:
            try:
                reihenfolgeString=dlg.textReihenfolge.GetValue()
                listeZeichen=reihenfolgeString.split(' ')
                liste=[]
                for zeichen in listeZeichen:
                    liste.append(int(zeichen))
            except ValueError as e:
                pass
        else:
            return
        if len(liste)!=len(parameterNamen) or\
           max(liste)!=len(parameterNamen):
            self.Meldung(u'Zahlenliste entspricht nicht'+
                         'der Anzahl der Attribute')
            return
        karte.SortiereParameter(name,liste)
        dlg.Destroy()
        event.Skip()
        
    ### ----- Loeschen-Menue ------------------------
    def OnKlasseLoeschen(self, event):
        klasse=self.__controller.GibAusgewaehlte()
        if klasse==None: return
        dlg = wx.MessageDialog(self, u'Klasse'+klasse.GibNamen()+u' löschen?',
                               'Sicherheitsabfrage',
                               wx.YES_NO)
        returnValue = dlg.ShowModal()
        if returnValue == wx.ID_NO:
            dlg.Destroy()
            return
        dlg.Destroy()
        self.__controller.LoescheAusgewaehlte()
        self.xEdit.SetValue('')
        self.yEdit.SetValue('')
        event.Skip()

    def OnAttributLoeschen(self, event):
        karte=self.__controller.GibAusgewaehlte()
        if karte==None: return
        attribute=karte.GibAttribute()
        attributNamen=[]
        for attribut in attribute:
            attributNamen.append(attribut[0])
        name=self.Auswahldialog("Attribut Loeschen:",attributNamen)
        if name==None: return
        self.__controller.LoescheAttribut(name)
        event.Skip()

    def OnMethodeLoeschen(self, event):
        karte=self.__controller.GibAusgewaehlte()
        if karte==None: return
        methoden=karte.GibMethoden()
        methodenNamen=[]
        for methode in methoden:
            methodenNamen.append(methode[0])
        name=self.Auswahldialog("Methode Loeschen:",methodenNamen)
        if name==None: return
        self.__controller.LoescheMethode(name)
        event.Skip()
        
    def OnParameterLoeschen(self, event):
        karte=self.__controller.GibAusgewaehlte()
        if karte==None: return
        n,xy,a,methoden,s=karte.GibDatenTextlich()
        methodenliste=eval(methoden) # String zu Liste entpacken
        if methodenliste==[]: return # nichts zu bearbeiten
        methodennamen=[] # Namen heraus holen
        for m in methodenliste: methodennamen.append(m[0])
        liste=[]
        name = self.Auswahldialog('Methode waehlen', methodennamen)
        if name==None: return
        parameterListe=karte.GibParameterZuMethName(name)
        parameterNamen=[]
        for par in parameterListe:
            parameterNamen.append(par[0])
        parameterName = self.Auswahldialog(u'Parameter löschen zu Methode',
                                       parameterNamen)
        if parameterName==None: return

        karte.LoescheParameter(name,parameterName)
        event.Skip()                
        
    def OnVerbinderLoeschen(self, event):
        verbinderTexte=self.__controller.GibVerbinderMitTyp()
        verbinder=self.Auswahldialog("Verbinder Loeschen:",verbinderTexte)
        if verbinder==None: return
        auswahl=verbinder.split(' ')
        self.__controller.LoescheVerbinder(auswahl)
        event.Skip()

    ### ----- Textfeld-Ereignisse -------------------------------
    def EvtXEdit(self, event):
        if self.__sperreEreignisbehandlung: return
        karte=self.__controller.GibAusgewaehlte()
        if karte==None: return
        x0=karte.GibX()
        try:
            x=int(self.xEdit.GetValue())
        except ValueError as e:
            x=0
        if x!=x0: karte.Bewege(x-x0,0)
        event.Skip() ## notwendig, damit Ereignis voll behandelt wird

    def EvtYEdit(self, event):
        if self.__sperreEreignisbehandlung: return
        karte=self.__controller.GibAusgewaehlte()
        if karte==None: return
        y0=karte.GibY()
        try:
            y=int(self.yEdit.GetValue())
        except ValueError as e:
            y=0
        if y!=y0: karte.Bewege(0,y-y0)
        event.Skip() ## notwendig

    def EvtWinkel(self, event):
        if self.__sperreEreignisbehandlung: return
        if self.__controller.NichtsAusgewaehlt(): return
        try:
            winkel=int(self.winkelEdit.GetValue())
        except ValueError as e:
            winkel=0
        self.__controller.NeuerWinkel(winkel)
        event.Skip() ## notwendig

    def UpdateDaten(self, xString, yString, wString):
        '''fuehrt ein Update der Daten in den Textfeldern durch'''
        self.__sperreEreignisbehandlung=True
        self.xEdit.SetValue(xString)
        self.yEdit.SetValue(yString)
        self.winkelEdit.SetValue(wString)
        self.__sperreEreignisbehandlung=False

    def Auswahldialog(self, text, auswahlen):
        dlg = wx.SingleChoiceDialog(
                self, u'Auswählen', text,
                auswahlen, 
                wx.CHOICEDLG_STYLE
                )

        if dlg.ShowModal() == wx.ID_OK:
            return dlg.GetStringSelection()
        else:
            return None
        dlg.Destroy()

    def Meldung(self, text):
        dlg = wx.MessageDialog(self, text,
                               'ACHTUNG !',
                               wx.OK | wx.ICON_INFORMATION
                               #wx.YES_NO | wx.NO_DEFAULT | wx.CANCEL | wx.ICON_INFORMATION
                               )
        dlg.ShowModal()
        dlg.Destroy()
        
        

    ### ----- Standard-Ereignisse -------------------------------
    def OnCloseMe(self, event):
        self.Close(True)

    def OnCloseWindow(self, event):
        if self.__controller.IstGeaendert():
            dlg = wx.MessageDialog(self, u'Wirklich beeenden?',
                                   'Sicherheitsabfrage',
                                   wx.YES_NO)
            returnValue = dlg.ShowModal()
            if returnValue == wx.ID_NO:
                dlg.Destroy()
                return
            dlg.Destroy()
        self.Destroy()
        
### ---------------------------------------------------
class GuiApp(wx.App):
    """Testanwendung fuer Raumplaner-Grafik
       ShellFrame: Interaktion mit laufender Anwendung
       FillingFrame: Anzeige der Umgebung"""
    def OnInit(self):
        self.gui = Gui(None, -1, "Raumplaner-Gui") #<-
        self.gui.Show(True) #<-
        return True


### ---------------------------------------------------
if __name__ == '__main__':
    app = GuiApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()

