# -*- coding: utf-8 -*-
# konfigurationAttribut.py
import  wx

provider = wx.SimpleHelpProvider()
wx.HelpProvider.Set(provider)


class KonfigurationAttribut(wx.Dialog):
    def __init__(
            self, parent,ID,title,
            name,typ,isAbstract,isClassVar,
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):

        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        label = wx.StaticText(self, -1, "Konfiguration des Attributs")
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        # Name des Attributs
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Name", size=(80,-1))
        label.SetHelpText(u"Ändern Sie den Namen")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        self.textName = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textName.SetHelpText("Attributname")
        self.textName.ChangeValue(name)
        box.Add(self.textName, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # Typ des Attributs
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Typ",size=(80,-1))
        label.SetHelpText("Aendern Sie den Typ")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textTyp = wx.TextCtrl(self, -1, "", size=(80,-1))
        self.textTyp.SetHelpText("Typ des Attributs")
        self.textTyp.ChangeValue(typ)
        box.Add(self.textTyp, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        # Abstrakt ?
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "abstrakt ?")
        label.SetHelpText(u"auswählen, wenn")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        

        self.cbAbstrakt = wx.CheckBox(self, -1, "ist abstrakt", size=(280,-1))
        self.cbAbstrakt.SetHelpText(u"abstrakt wählen")
        box.Add(self.cbAbstrakt, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.cbAbstrakt.SetValue(isAbstract)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)

        # Klassenvariable ?
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Klassenvariable ?")
        label.SetHelpText(u"auswählen, ob")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        

        self.cbClassVar = wx.CheckBox(self, -1, "ist Klassenvariable", size=(280,-1))
        self.cbClassVar.SetHelpText("ist Klassenvariable")
        box.Add(self.cbClassVar, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        self.cbClassVar.SetValue(isClassVar)

        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)
        
        # Trennlinie
        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.RIGHT|wx.TOP, 5)

        btnsizer = wx.StdDialogButtonSizer()
        
        if wx.Platform != "__WXMSW__":
            btn = wx.ContextHelpButton(self)
            btnsizer.AddButton(btn)
        
        okbtn = wx.Button(self, wx.ID_OK)
        okbtn.SetHelpText("Beenden und uebernehmen")
        okbtn.SetDefault()
        btnsizer.AddButton(okbtn)
        self.Bind(wx.EVT_BUTTON, self.OnOKButton, okbtn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btn.SetHelpText("Abbruch ohne die Werte zu uebernehmen")
        btnsizer.AddButton(btn)
        btnsizer.Realize()
        self.Bind(wx.EVT_BUTTON, self.OnCancelButton, btn)

        sizer.Add(btnsizer, 0, wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)

    def DatenSetzen(self, name, typ, istAbstract, isClassVar):
        self.textName.ChangeValue(name)
        self.textTyp.ChangeValue(typ)
        self.cbAbstrakt.SetValue(istAbstract)
        self.cbClassVar.SetValue(isClassVar)

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)
