# -*- coding: utf-8 -*-
# konfigurationReihenfolge.py
import platform
versionsNummer=platform.python_version()[0]
### Kommentar zum Einfuegen neuer Parameter bei Py3
### Ich kann mir zwar vorstellen, was dahinter steckt,
### dass Py3 immer am Anfang der Liste neue Elemente einfuegt,
### habe aber keine Lust das hier zu heilen.
### Leider steckt die Verwaltung im Hintergrund und ist fuer
### mich nicht so leicht auszutricksen.
import sys
import  wx
import  wx.lib.mixins.listctrl  as  listmix

provider = wx.SimpleHelpProvider()
wx.HelpProvider.Set(provider)

#---------------------------------------------------------------------------
class NamenListCtrl(wx.ListCtrl,
                   listmix.ListCtrlAutoWidthMixin,
                   listmix.TextEditMixin
                   ):

    def __init__(self, parent, ID, daten,
                 pos=wx.DefaultPosition,
                 size=wx.DefaultSize, style=0,):
        wx.ListCtrl.__init__(self, parent, ID, pos, size, style)
        self.daten=daten
##        self.listctrldata=dict()
        self.SetzeDaten(daten)

        listmix.ListCtrlAutoWidthMixin.__init__(self)

        self.InsertColumn(0, "Reihenfolge")
        self.InsertColumn(1, "Name des Attributs")

        self.Erzeuge()

        self.SetColumnWidth(0, 100)
        self.SetColumnWidth(1, 100)
        self.currentItem = 0
        listmix.TextEditMixin.__init__(self)

    def Erzeuge(self):
        items = self.listctrldata.items()
        ## Fuer Py3 geht nichtsys.maxint
        index=0 # nur initialisieren
        if versionsNummer=='2':           
            for key, data in items:
                    index = self.InsertStringItem(sys.maxint, data[0])
                    self.SetStringItem(index, 0, str(index+1))
                    self.SetStringItem(index, 1, data)
                    self.SetItemData(index, key)
        else:
            ## Kommentar s.o.
            for key, data in items:
                index = self.InsertItem(self.GetItemCount(), data[0])
                self.SetItem(index, 0, str(index+1))
                self.SetItem(index, 1, data)
                self.SetItemData(index, key)
            
    def SetStringItem(self, index, col, data):
        if col in range(2):
            if versionsNummer=='2':
                wx.ListCtrl.SetStringItem(self, index, col, data)
            else:
                wx.ListCtrl.SetItem(self, index, col, data)

    def SetzeDaten(self, daten):
        '''<name>'''
        self.listctrldata = dict()
        for index in range(len(daten)):
            self.listctrldata.update({index:daten[index]})

### -------------------------------------------------------------
class KonfigurationReihenfolge(wx.Dialog):
    def __init__(
            self, parent,
            ID, title,
            namenZumSortieren,
            size=wx.DefaultSize, pos=wx.DefaultPosition, 
            style=wx.DEFAULT_DIALOG_STYLE):
        
        wx.Dialog.__init__(self, parent, ID, title, pos, size, style)

        sizer = wx.BoxSizer(wx.VERTICAL)

        # Auswahl-Textfeld
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, "Reihenfolge durch Zeilennummer angeben\n"+
                              "1 2 3 4 5")
        label.SetHelpText(u"Ändern Sie den Namen")
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.textReihenfolge = wx.TextCtrl(self, -1, "1 2 3", size=(200,-1))
        self.textReihenfolge.SetHelpText("Reihenfolge durch Zeilennummer angeben")
        box.Add(self.textReihenfolge, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        sizer.Add(box, 0, wx.GROW|wx.ALL, 5)


        # Auswahlen
        box = wx.BoxSizer(wx.HORIZONTAL)

        self.git=NamenListCtrl(self, -1,
                                   namenZumSortieren,
                                   style=wx.LC_REPORT
                                   | wx.BORDER_NONE
                                   | wx.LC_SORT_ASCENDING
                                   )
        sizer.Add(self.git, 1, wx.EXPAND)
        
        
        # Trennlinie
        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.RIGHT|wx.TOP, 5)

        btnsizer = wx.StdDialogButtonSizer()
        
        if wx.Platform != "__WXMSW__":
            btn = wx.ContextHelpButton(self)
            btnsizer.AddButton(btn)
        
        okbtn = wx.Button(self, wx.ID_OK)
        okbtn.SetHelpText("Beenden und uebernehmen")
        okbtn.SetDefault()
        btnsizer.AddButton(okbtn)
        self.Bind(wx.EVT_BUTTON, self.OnOKButton, okbtn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btn.SetHelpText("Abbruch ohne die Werte zu uebernehmen")
        btnsizer.AddButton(btn)
        btnsizer.Realize()
        self.Bind(wx.EVT_BUTTON, self.OnCancelButton, btn)

        sizer.Add(btnsizer, 0, wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)

    def OnNeuerParameter(self, evt):
        aktuelleDaten=self.git.VerlaengereDaten()

    def OnOKButton(self, evt):
        self.EndModal(wx.ID_OK)

    def OnCancelButton(self, evt):
        self.EndModal(wx.ID_CANCEL)

