# -*- coding: utf-8 -*-
# verbinder.py


import platform
versionsNummer=platform.python_version()[0]
import math

from figuren import *
from figurenGruppe2 import FigurenGruppe2
from klassenkarte import Klassenkarte

### ----- globale Hilfsfunktion -----------------------
def Zwischen(x, klein, gross): return x>=klein and x<=gross

### ---------------------------------------------------
class Verbinder(object):
    """Linie oder Pfeil fuer UML-Diagramme
    Verbinder wird wie eine abstrakte Klasse behandelt."""

    def __init__(self,
                 x0=100, y0=100, x1=200, y1=150,
                 name='',
                 richtung=0,
                 typ=0):
        self.__x0,self.__y0,self.__x1,self.__y1 = x0,y0,x1,y1
        self.__name = name
        self.__richtung=richtung
        self.__typ=typ
        self.SetzeFigur(self.GibFigur())
        self.Zeige()

    ## Get-Methoden
    def GibStart(self): return self.__x0,self.__y0
    def GibZiel(self): return self.__x1,self.__y1
    def GibDaten(self): return self.__x0,self.__y0,self.__x1,self.__y1
    def GibNamen(self): return self.__name
    def GibRichtung(self): return self.__richtung
    def GibTyp(self): return self.__typ

    def GibFigur(self):
        '''definiert die Figur als waagerechten Pfeil, aber mit
        richtiger Laenge und setzt den Winkel richtig'''
        x0,y0,x1,y1=self.GibDaten()
        laenge=math.sqrt((x1-x0)**2+(y1-y0)**2)
        if laenge<30: laenge=30 # Pfeil zu kurz
        if (int(x1-x0)==0) and (y1>y0): winkel=90
        elif (int(x1-x0)==0) and (y1<=y0): winkel=270
        elif x1>x0:
            winkel=math.atan((y1-y0)/float(x1-x0))*180/math.pi
        else:
            winkel=180+math.atan((y1-y0)/float(x1-x0))*180/math.pi
        figur=FigurenGruppe2(x0,y0,winkel)
        figur.FuegeHinzu(Linie(0, 0, laenge, 0)) # Linie braucht breite und hoehe
        if self.__richtung==1:
            figur.FuegeHinzu(
                N_Eck(laenge-15,0,((0,-7),(15,0),(0,7)),
                      geschlossen=False))
        if self.__typ==1:
            figur.FuegeHinzu(
                N_Eck(0,0,((0,0),(15,-5),(30,0),(15,5)),fuellfarbe='white'))
        elif self.__typ==2:
            figur.FuegeHinzu(
                N_Eck(0,0,((0,0),(15,-5),(30,0),(15,5)),fuellfarbe='black'))
        if self.__typ==3:
            figur.FuegeHinzu(
                N_Eck(laenge,0,((-20,-8),(0,0),(-20,8)),fuellfarbe='white'))
        return figur

    def SetzeStart(self, koordinaten):
        self.__x0,self.__y0=koordinaten
        self.__figur.Verberge()
        self.SetzeFigur(self.GibFigur())
        self.__figur.Zeige()

    def SetzeZiel(self, koordinaten):
        self.__x1,self.__y1=koordinaten
        self.__figur.Verberge()
        self.SetzeFigur(self.GibFigur())
        self.__figur.Zeige()

    def SetzeFigur(self, figur):
        self.__figur=figur

    def SetzeRichtung(self, richtung):
        '''Setzt Pfeil oder nicht neu'''
        self.Verberge()
        self.__richtung=richtung
        self.SetzeFigur(self.GibFigur())
        self.Zeige()

    def SetzeTyp(self, typ):
        '''setzt den Typ neu'''
        if typ in (0,1,2,3):
            self.Verberge()
            self.__typ=typ
            self.SetzeFigur(self.GibFigur())
            self.Zeige()

    def Verberge(self):
        if self.__figur==None: return
        self.__figur.Verberge()
        
    def Zeige(self):
        if self.__figur==None:
            self.__figur=self.GibFigur()
        self.__figur.Zeige()

### ---------------------------------------------------

class TestApp(wx.App):
    """Test-Anwendung"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Klassendiagramm")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.__fenster.ZeigeShellFrame()
        self.TestAnwendung()
        #self.__fenster.ZeigeFillingFrame()
        return True

    def TestAnwendung(self):
        """Test-Methode fuer Klassendiagramm"""
        global v
        v=Verbinder(20, 20, 100, 150)


### ---------------------------------------------------
if __name__ == '__main__':
    app = TestApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()

