# -*- coding: utf-8 -*-
# verbinder1.py

## rechtwinklige Verbindung mit einem Winkel

import platform
versionsNummer=platform.python_version()[0]
import math

from figuren import *
from verbinder import Verbinder


### ---------------------------------------------------
class Verbinder1(Verbinder):
    """Linie oder Pfeil fuer UML-Diagramme
    Verbinder wird wie eine abstrakte Klasse behandelt.
    In dieser Variante werden zwei zu einander senkrechte Linien
    verwendet"""

    def __init__(self,
                 x0, y0, x1, y1,
                 name='',
                 anschluss='NO', # alle Kombinationen moeglich
                 richtung=0, # Pfeil?
                 typ=0
                 ): 
        self.__anschluss=anschluss # wie in die Karte hinein,
        ## also die Orientierung der zweiten Linie
        Verbinder.__init__(self,x0,y0,x1,y1,name,richtung,typ)
        # Figur als FigurenGruppe initialisieren

    def GibFigur(self):
        '''setzt die aktuelle Figur'''
        x0,y0,x1,y1 = self.GibDaten()
        b,h=x1-x0,y1-y0
        figur=FigurenGruppe(x0,y0)
        if self.__anschluss[1]=='W': # von links hinein
            figur.FuegeHinzu(Linie(0,0,0,h))
            figur.FuegeHinzu(Linie(0,h,b,0))
            if self.GibRichtung()==1: # Pfeil zeichnen
                figur.FuegeHinzu(
                    N_Eck(b,h,((-15,-7),(0,0),(-15,7)),
                          geschlossen=False))
            elif self.GibTyp()==3: # Vererbungspfeil
                figur.FuegeHinzu(
                    N_Eck(b,h,((-20,-8),(0,0),(-20,8)),
                          fuellfarbe='white'))
        elif self.__anschluss[1]=='O': # von rechts hinein
            figur.FuegeHinzu(Linie(0,0,0,h))
            figur.FuegeHinzu(Linie(0,h,b,0))
            if self.GibRichtung()==1: # Pfeil zeichnen
                figur.FuegeHinzu(
                    N_Eck(b,h,((15,-7),(0,0),(15,7)),
                          geschlossen=False))
            elif self.GibTyp()==3: # Vererbungspfeil
                figur.FuegeHinzu(
                    N_Eck(b,h,((20,-8),(0,0),(20,8)),
                          fuellfarbe='white'))
        elif self.__anschluss[1]=='N': # von oben hinein
            figur.FuegeHinzu(Linie(0,0,b,0))
            figur.FuegeHinzu(Linie(b,0,0,h))
            if self.GibRichtung()==1: # Pfeil zeichnen
                figur.FuegeHinzu(
                    N_Eck(b,h,((-7,-15),(0,0),(7,-15)),
                          geschlossen=False))
            elif self.GibTyp()==3: # Vererbungspfeil
                figur.FuegeHinzu(
                    N_Eck(b,h,((-8,-20),(0,0),(8,-20)),
                          fuellfarbe='white'))
        else:                   # 'S'
            figur.FuegeHinzu(Linie(0,0,b,0))
            figur.FuegeHinzu(Linie(b,0,0,h))
            if self.GibRichtung()==1: # Pfeil zeichnen
                figur.FuegeHinzu(
                    N_Eck(b,h,((-7,15),(0,0),(7,15)),
                          geschlossen=False))
            elif self.GibTyp()==3: # Vererbungspfeil
                figur.FuegeHinzu(
                    N_Eck(b,h,((-8,20),(0,0),(8,20)),
                          fuellfarbe='white'))
        # Raute ?
        if not(self.GibTyp() in (1,2)): return figur
        if self.GibTyp()==1: ff='white'
        if self.GibTyp()==2: ff='black'
        if self.__anschluss[0]=='O':
            figur.FuegeHinzu(
                N_Eck(0,0,((0,0),(15,-5),(30,0),(15,5)),fuellfarbe=ff))
        elif self.__anschluss[0]=='W':
            figur.FuegeHinzu(
                N_Eck(0,0,((0,0),(-15,-5),(-30,0),(-15,5)),fuellfarbe=ff))
        elif self.__anschluss[0]=='S':
            figur.FuegeHinzu(
                N_Eck(0,0,((0,0),(-5,15),(0,30),(5,15)),fuellfarbe=ff))
        else:                   # 'N'
            figur.FuegeHinzu(
                N_Eck(0,0,((0,0),(-5,-15),(0,-30),(5,-15)),fuellfarbe=ff))
        return figur

##    def AendereRichtungInKarte(self):
##        self.Verberge()
##        self.__waagerecht=not(self.__waagerecht)
##        self.SetzeFigur(self.GibFigur())
##        self.Zeige()
            
### ---------------------------------------------------

class TestApp(wx.App):
    """Test-Anwendung"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Klassendiagramm")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.__fenster.ZeigeShellFrame()
        self.TestEinfach()
        #self.__fenster.ZeigeFillingFrame()
        return True

        
    def TestEinfach(self):
        '''isoliert die vier Faelle'''
        global v,v1,v2,v3,v4
        ##v=Verbinder1(120, 200, 180, 50, richtung=1) #'NO'
        v1=Verbinder1(180, 50, 120, 200, richtung=1) #'NO'
##        v1=Verbinder1(10, 100, 80, 50) #'ON'
##        v2=Verbinder1(300, 100, 350, 150) #'SO'
##        v3=Verbinder1(100, 300, 50, 350) #'SW'
##        v4=Verbinder1(300, 300, 250, 250) #'NW'

##        v.AendereRichtungInKarte()

### ---------------------------------------------------
if __name__ == '__main__':
    app = TestApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()

